Option Explicit

Const ForAppending = 8
Const ForReading = 1
Const ForWriting = 2

Const TristateFalse = 0
Const TristateMixed = -2
Const TristateTrue = -1
Const TristateUseDefault = -2

Dim objDialog, objDialogs, objExec, objFile, objFSO, objRE, objScriptFile, wshShell
Dim strDialog, strFile, strScriptFile

Set objDialogs = CreateObject( "System.Collections.ArrayList" )
Set objFSO     = CreateObject( "Scripting.FileSystemObject" )
Set wshShell   = CreateObject( "WScript.Shell" )
Set objRE      = New RegExp
objRE.Pattern  = "^DialogBoxes\.[a-zA-Z]+Box\.cs$"

' List available dialogs
For Each objFile In objFSO.GetFolder( objFSO.GetAbsolutePathName( "." ) ).Files
	strFile = objFile.Name
	If objRE.Test( strFile ) Then
		strDialog = Split( objFile.Name, "." )(1)
		objDialogs.Add strDialog
	End If
Next
objDialogs.Add "SystemTrayMessage"
objDialogs.Sort
Set objRE = Nothing

' Create script with samplecode for all dialogs
strScriptFile = "DialogBoxes.SampleCode.vbs"
If objFSO.FileExists( strScriptFile ) Then objFSO.DeleteFile strScriptFile, True
Set objScriptFile = objFSO.OpenTextFile( strScriptFile, ForAppending, True, TristateFalse )
objScriptFile.WriteLine "WScript.Echo ""Script started at "" & Now"
For Each strDialog In objDialogs
	'On Error Resume Next
	Set objDialog = CreateObject( "RobvanderWoude." & strDialog )
	If Not Err Then
		objScriptFile.WriteLine "WScript.Echo vbCrLf"
		objScriptFile.WriteLine "WScript.Echo vbCrLf"
		objScriptFile.WriteLine "WScript.Echo """ & strDialog & """" & vbCrLf & vbCrLf
		objScriptFile.WriteLine objDialog.SampleCode( ) & vbCrLf & vbCrLf & vbCrLf
	End If
	Set objDialog = Nothing
	On Error GoTo 0
Next
objScriptFile.WriteLine "WScript.Echo ""Script finished at "" & Now"
objScriptFile.Close
Set objScriptFile = Nothing
Set objDialogs    = Nothing
Set objFSO        = Nothing

' Run sample code
Set objExec  = wshShell.Exec( "CSCRIPT.EXE //NoLogo " & strScriptFile & " 2>&1" )
WScript.Echo objExec.StdOut.ReadAll( )
Set objExec  = Nothing
Set wshShell = Nothing
